﻿using System;
using System.Runtime.Remoting.Channels;

namespace ExploitRemotingService
{
    internal class ChannelUriFixingClientChannelSinkProvider : IClientChannelSinkProvider
    {
        private readonly string publicHost;

        public IClientChannelSinkProvider Next { get; set; }

        public ChannelUriFixingClientChannelSinkProvider(string publicHost)
        {
            this.publicHost = publicHost;
        }

        public IClientChannelSink CreateSink(IChannelSender channel, string url, object remoteChannelData)
        {
            IClientChannelSink clientChannelSink = null;
            if (this.Next != null)
            {
                url = new UriBuilder(url)
                {
                    Host = this.publicHost,
                }.ToString();
                clientChannelSink = this.Next.CreateSink(channel, url, remoteChannelData);
            }
            return clientChannelSink;
        }
    }
}